//My run stuff.

var RunMode = false;

/**
  Tile movement script
  To use you have to do:
  
  RequireScript("tile_movement.js");
  SetUpdateScript("UpdateMovement()");
*/
var g_still_to_move = -1;
var g_last_command = -1;
var g_allow_movement = true;
var g_tile_movement = true;
var g_keys_pressed = new Array();

function AddKey(key) {
  g_keys_pressed.push(key);
}

function RemoveKey(key) {
  for (var i = 0; i < g_keys_pressed.length; i++) {
    if (g_keys_pressed[i] == key)
      g_keys_pressed.splice(i, 1);
  }
}

function UpdateTileMovement()
{
  var person = GetInputPerson();

  if(g_allow_movement)
  {
    if (g_keys_pressed.length > 0)
    {  
      if(g_still_to_move <= 0 && IsCommandQueueEmpty(person))
      {
        var delta_x = 0;
        var delta_y = 0;
        var move_command = COMMAND_WAIT;
        var face_command = COMMAND_WAIT;

        if (g_keys_pressed[g_keys_pressed.length - 1] == KEY_UP)    move_command = COMMAND_MOVE_NORTH;
        if (g_keys_pressed[g_keys_pressed.length - 1] == KEY_RIGHT) move_command = COMMAND_MOVE_EAST;
        if (g_keys_pressed[g_keys_pressed.length - 1] == KEY_DOWN)  move_command = COMMAND_MOVE_SOUTH;
        if (g_keys_pressed[g_keys_pressed.length - 1] == KEY_LEFT)  move_command = COMMAND_MOVE_WEST;

        switch (move_command)
        {
          case COMMAND_MOVE_NORTH:
            face_command = COMMAND_FACE_NORTH;
            delta_y = g_tile_movement ? (GetTileHeight() / GetPersonSpeedY(person)) : GetPersonSpeedY(person);
            delta_y *= -1;
          break;
          case COMMAND_MOVE_EAST:
            face_command = COMMAND_FACE_EAST;
            delta_x = g_tile_movement ? (GetTileWidth() / GetPersonSpeedX(person)) : GetPersonSpeedX(person);
          break;
          case COMMAND_MOVE_SOUTH:
            face_command = COMMAND_FACE_SOUTH;
            delta_y = g_tile_movement ? (GetTileHeight() / GetPersonSpeedY(person)) : GetPersonSpeedY(person);
          break;
          case COMMAND_MOVE_WEST:
            face_command = COMMAND_FACE_WEST;
            delta_x = g_tile_movement ? (GetTileWidth() / GetPersonSpeedX(person)) : GetPersonSpeedX(person);
            delta_x *= -1;
          break;
        }
        
        if (move_command != g_last_command) {
          QueuePersonCommand(person, face_command, true);
          g_last_command = move_command;
        }       

        if( !IsPersonObstructed(person, GetPersonX(person) + delta_x, GetPersonY(person) + delta_y) ) {
          g_still_to_move = Math.max(Math.abs(delta_x), Math.abs(delta_y));
        }
      }
    }
    Delay(10);
  }
  
  if(g_still_to_move > 0 && IsCommandQueueEmpty(person))
  {
    switch(g_last_command)
    {
      case COMMAND_MOVE_NORTH:
       QueuePersonCommand(person, COMMAND_FACE_NORTH, true);
       QueuePersonCommand(person, COMMAND_MOVE_NORTH, false);
       if (RunMode == false) g_still_to_move -= 1;
       else g_still_to_move -= 2;
      break;
      case COMMAND_MOVE_EAST:
       QueuePersonCommand(person, COMMAND_FACE_EAST,  true);
       QueuePersonCommand(person, COMMAND_MOVE_EAST,  false);
       if (RunMode == false) g_still_to_move -= 1;
       else g_still_to_move -= 2;
      break;
      case COMMAND_MOVE_SOUTH:
       QueuePersonCommand(person, COMMAND_FACE_SOUTH, true);
       QueuePersonCommand(person, COMMAND_MOVE_SOUTH, false);
       if (RunMode == false) g_still_to_move -= 1;
       else g_still_to_move -= 2;
      break;
      case COMMAND_MOVE_WEST:
       QueuePersonCommand(person, COMMAND_FACE_WEST,  true);
       QueuePersonCommand(person, COMMAND_MOVE_WEST,  false);
       if (RunMode == false) g_still_to_move -= 1;
       else g_still_to_move -= 2;
      break;
    }
  }
}
