//Menu.js

var ItemAnswer = 0;
var CurrentItemSelectOption = 0;

//var MenuSpacing = 18;
var MenuSpacing = font.getHeight() + 4;

var CurrentMenuOption = 1;
var MenuOption = new Array("", "PokDEX", "Pokmon", "Bag", "PokGear", PersonName, "Save", "Settings", "Exit", "Back");

var MainMenuHeight = (MenuSpacing * MenuOption.length) - 10;


/*
--------------------------------------
MENU
--------------------------------------
*/

//MAKE THE MENU OPTIONS
function MakeMenuOptions()
{
if (PlayerPokemon[0] != undefined)
{
	//MenuOption = new Array("", "PokDEX", "Pokmon", "Bag", "PokGear", Player.Name, "Save", "Settings", "Exit", "Back");
	MenuOption = new Array("", "PokDEX", "Pokmon", "Bag", "PokGear", Player.Name, "Load", "Save", "Settings", "Exit", "Back");
}

else
{
	//MenuOption = new Array("", "Bag", "PokGear", Player.Name, "Save", "Settings", "Exit", "Back");
	MenuOption = new Array("", "Bag", "PokGear", Player.Name, "Load", "Save", "Settings", "Exit", "Back");
}
}



// MENU MAKE COMMANDS & PREPARATION
function MainMenu()
{
	//Preparation: finish moving on a tile
	FinishTile();
	
	//First of all, make the menu options. (if you get a Pokmon later this is crucial!)
	MakeMenuOptions();
	
	ClearTileMovement();
	if (IsMapEngineRunning()) RenderMap();
	
	MainMenuHeight = (MenuSpacing * MenuOption.length) - 10;
	WindowStyle.drawWindow(220, MenuSpacing, 90, MainMenuHeight);
	BlitMenuOptions();
	MenuRing.drawWindow(222, (MenuSpacing * CurrentMenuOption) + 2, 86, MenuSpacing - 2);
	RenderStuff();
	MenuWait();
}



// MAKE THE MAIN MENU
function MenuWait()
{
	
	GetKey();
	if (IsKeyPressed(KEY_UP) && CurrentMenuOption > 1)
	{
		CurrentMenuOption--;
		sound["beep"].stop();
		sound["beep"].play(false);
	}
	
	else if (IsKeyPressed(KEY_DOWN) && CurrentMenuOption < MenuOption.length - 1)
	{
		CurrentMenuOption++;
		sound["beep"].stop();
		sound["beep"].play(false);
	}
	
	else if (IsKeyPressed(KEY_CTRL))
	{
		sound["beep"].stop();
		sound["beep"].play(false);
		CheckSelectedMenuOption();
		
		if (MenuOption[CurrentMenuOption] == "Save" || MenuOption[CurrentMenuOption] == "Load")
			return;
	}
	
	else if (IsKeyPressed(KEY_ALT))
	{
		return;
	}
	
	WindowStyle.drawWindow(220, MenuSpacing, 90, MainMenuHeight);
	BlitMenuOptions();
	MenuRing.drawWindow(222, (MenuSpacing * CurrentMenuOption) + 2, 86, MenuSpacing - 2);
	RenderStuff();
	
	if (MenuOption[CurrentMenuOption] != "Back" || !IsKeyPressed(KEY_CTRL)) MenuWait();
}



// BLIT THE MENU OPTION TEXT
function BlitMenuOptions()
{
var m = 1;
var total = MenuOption.length;

for (m = 1; m < total; m++)
{
	MenuFont.drawText(225, (m*MenuSpacing) + 4, MenuOption[m]);
}
}


// CHECK THE CURRENT SELECTED MAIN MENU OPTION
function CheckSelectedMenuOption()
{
	//TextBox preparation.
	TextBox.surface = true;
	TextBox.mapEngine = false;
	
	//If selected option exists, start one of the following.
	if (MenuOption[CurrentMenuOption] == "PokDEX") TextBox("PokDEX -- to be implemented.");
	else if (MenuOption[CurrentMenuOption] == "Pokmon") PokemonMenuMain();
	else if (MenuOption[CurrentMenuOption] == "Bag") PrepareOpenBag();
	else if (MenuOption[CurrentMenuOption] == Player.Name) PersonStatScreen();
	else if (MenuOption[CurrentMenuOption] == "PokGear") TextBox("The POKGEAR will be available in a later version of POKMON GS/SS.");
	else if (MenuOption[CurrentMenuOption] == "Save") SaveGame();
	else if (MenuOption[CurrentMenuOption] == "Settings") TextBox("Settings -- to be implemented.");
	else if (MenuOption[CurrentMenuOption] == "Exit") AskQuit();
	else if (MenuOption[CurrentMenuOption] == "Back") return;
	
	else if (MenuOption[CurrentMenuOption] == "Load") LoadGame();
	
	else TextBox("You've selected an option that doesn't exist.");
	
	TextBox.surface = false;
	TextBox.mapEngine = true;
}


//ASK TO QUIT
//  ASK TO QUIT
//    ASK TO QUIT
function AskQuit()
{
	YesNoQuestion("Quit?");
	if (YesNoQuestion.answer) Exit();
}


//YES / NO QUESTION
//  YES / NO QUESTION
//    YES / NO QUESTION
function YesNoQuestion(Question)
{
	//NEW VERSION! From a LOT of lines to just a few lines! More flexibility, too!
	this.answer;
	
	//Turn off the textbox wait for key and its sound playing. Then show the textbox.
	TextBox.getKey = false;
	TextBox.playsound = false;
	TextBox(Question);
	
	//Turn off map engine blitting and turn on surface blitting for the menu.
	TextBox.surface = true;
	
	//Show the menu!
	var options = new Array("YES", "NO");
	Menu(40, 140, 50, options)
	
	//Revert settings.
	TextBox.surface = false;
	TextBox.getKey = true;
	TextBox.playsound = true;
	
	if (Result == 0)
		YesNoQuestion.answer = true;
	
	if (Result == 1)
		YesNoQuestion.answer = false;
	
}





/*
========================
		PERSON STATUS SCREEN
========================
*/

function PersonStatScreen()
{
	var background = LoadImage("GUI/PlayerStat/player1back.png");
	var CardFront = LoadImage("GUI/PlayerStat/tCardFront.png");
	
	background.blit(0, 0);
	
	var x = (SW - CardFront.width) / 2;
	var y = (SH - CardFront.height) / 2;
	CardFront.blit(x, y);
	
	
	font.drawTextBox(105, 79, 200, 20, 0, Player.Name.toUpperCase());
	font.drawText(153, 106, "$" + Player.money);
	
	Player.image.blit(220, 90);
	
	RenderStuff();
	GetKey();
}



//=========================
//		MAKE A MENU
//=========================

var Result;		//Menu Result is stored in here.
var options = new Array(undefined);
var MenuSpecial;

function Menu(x, y, w, options)
{
	//New thingy to get the result.
	this.result;
	this.font;
	this.windowStyle;
	
	this.surface;
	
	//Let's start adding the options!
	var h = options.length * MenuSpacing;
	var done = false;
	var Current = 0;
	
	while (!done)
	{
		//New function that draws the previous screen:
		if (Game.surface != undefined) Game.surface.blit(0, 0);
		
		//FIRST: Some specials.
		if (MenuSpecial == "PokeMenu")
		{
			PokeMenuRender();
			Rectangle(0, 0, SW, SH, TransBlack);
		}

		Menu.windowStyle.drawWindow(x, y, w, h);
		for (var i = 0; i < options.length; i++)
		{
			Menu.font.drawText(x + 5, y + 2 + (i*MenuSpacing), options[i]);
		}
		
		MenuRing.drawWindow(x + 2, y + 1 + (Current*MenuSpacing), w - 4, MenuSpacing - 3);

		//Now for some selected option checking
		
		RenderStuff();
		
		GetKey();
		if (IsKeyPressed(KEY_UP) && Current > 0)
		{
			sound["beep"].stop();
			sound["beep"].play(false);
			Current--;
		}
		
		else if (IsKeyPressed(KEY_DOWN) && Current < options.length - 1)
		{
			sound["beep"].stop();
			sound["beep"].play(false);
			Current++;
		}
		
		else if (IsKeyPressed(KEY_CTRL))
		{
			sound["beep"].stop();
			sound["beep"].play(false);
			Result = Current;
			Menu.result = Current;
			done = true;
		}
		
		else if (IsKeyPressed(KEY_ALT))
		{
			sound["beep"].stop();
			sound["beep"].play(false);
			Result = undefined;
			Menu.result = undefined;
			done = true;
		}
	}
	
	MenuSpecial = undefined;
}



	Menu.font = mFont;
	Menu.windowStyle = mWindowStyle;
	Menu.surface = true;
	