//PokemonMenu.js

var PMResult = 1;		//Pokemenu result


//POKEMON MENU
//Pokemon Menu is the standard Pokmon menu.
//It returns the selected Pokmon to the variable 'PMResult'.
//It returns usedItem if CTRL was pressed. Need to change this to something less confusing! XD

var Selected = 0;

function PokemonMenu()
{
PokeMenuRender();

FlipScreen();
if (IsMapEngineRunning()) RenderMap();


//UP/DOWN/SELECT KEYPRESS
GetKey();
PMResult = Selected;

if (IsKeyPressed(KEY_UP) && Selected > 0)
{
	Selected--;
	sound["beep"].stop();
	sound["beep"].play(false);
}

else if (IsKeyPressed(KEY_DOWN) && Selected < PlayerPokemon.length-1)
{
	Selected++;
	sound["beep"].stop();
	sound["beep"].play(false);
}


else if (IsKeyPressed(KEY_CTRL))
{
	usedItem = true;
	sound["beep"].stop();
	sound["beep"].play(false);
	return;
}

else if (IsKeyPressed(KEY_ALT))
{
	PMResult = PlayerPokemon.length;
	sound["beep"].stop();
	sound["beep"].play(false);
	return;
}

PokemonMenu();
}



//ONLY RENDER THE POK MENU.
function PokeMenuRender()
{
pkmnMenuBack.blit(0, 0);

//How messy.
for (var i = 0; i < 5; i++)
{
	if (PlayerPokemon[i] != undefined)
	{
		var height = 24;
		var x = 90;
		
		SelectOff.blit(x, (height*i)+28);		//Select pkmn Background image
		
		if (i == Selected)
			SelectOn.blit(x, (height*Selected)+28);		//Selected pkmn background
		
		Font.drawText(x + 20, (height*i)+31, PlayerPokemon[i].name);		//Pokmon name
		Rectangle(x + 87, (height*i)+35, 50, 3, HPgrey);		//Grey background behind HP bar
		
		var HPmeter = PlayerPokemon[i].HP / PlayerPokemon[i].maxHP;
		var maxHP = PlayerPokemon[i].maxHP;
		
		//Color check
		//25% or lower: red meter.
		if (PlayerPokemon[i].HP < maxHP/4)
		{
			Rectangle(x + 87, (height*i)+36, HPmeter*50, 3, HPred);
		}
		
		//25 - 50%: orange meter.
		else if (PlayerPokemon[i].HP < maxHP/2)
		{
			Rectangle(x + 87, (height*i)+36, HPmeter*50, 3, HPorange);
		}
		
		//50 - 100%: green meter.
		else
		{
			Rectangle(x + 87, (height*i)+36, HPmeter*50, 3, HPgreen);
		}
		
		Rectangle(x + 87, (height*i)+36, 50, 1, HPshadow);
		i_HPmeter.blit(x + 73, (height*i)+34);		//HP image
		
		var HPnumbers = PlayerPokemon[i].HP + "/" + PlayerPokemon[i].maxHP;
		var HPnumberX = (x+139)-SmallFont.getStringWidth(HPnumbers);
		SmallFont.drawText(HPnumberX, (height*i)+39, HPnumbers);		//HP numbers
		
		SmallFont.drawText(x + 25, (height*i)+39, "Lv" + PlayerPokemon[i].level);		//Level
		
	}
}
}
	



//=========================================
//		ENTERING THE POK MENU FROM THE MAIN MENU
//=========================================
function PokemonMenuMain()
{
	RenderMap();
	PokemonMenu();
	
	//usedItem isn't really used item here, but 'has the player pressed CTRL?'.
	if (usedItem)
	{
		//Reset usedItem to prevent bugs.
		usedItem = false;
		
		//Finally, the general Menu() function is done and ready for use! :D
		//Determine the Menu() layout.
		var TheMenu = new Array("SUMMARY", "SPECIAL MOVES", "SWITCH", "ITEM", "CANCEL");
		
		var x = SW / 3;
		var y = SH / 3;
		var w = 100;
		
		//Set a menu special for stuff that's extra for specific menus.
		MenuSpecial = "PokeMenu";
		mFont= TalkFont;
		Menu(x, y, w, TheMenu);
		
		//If a submenu option was chosen...
		//If ALT was pressed, this is skipped automatically.
		if (Result != undefined)
		{
			if (TheMenu[Result] == "SUMMARY")
			{
				//TextBox("Summary for " + PlayerPokemon[PMResult].name + " will come later...");
				PokemonSummary(PlayerPokemon[PMResult]);
			}
			
			else if (TheMenu[Result] == "SPECIAL MOVES")
			{
				TextBox("This Pokmon has no special moves. Or rather, special moves are not implemented in the game yet.");
			}
			
			else if (TheMenu[Result] == "SWITCH")
			{
				TextBox("Not able to switch yet.");
			}
			
			else if (TheMenu[Result] == "ITEM")
			{
				TextBox("Giving an item to a Pokmon? It's out of the question at the moment!");
			}
		}
		
		//Start from the beginning.
		PokemonMenuMain();
	}
}





//=============================
//		SUMMARY SCREEN
//=============================
//A summary screen for the Pokmon.


function PokemonSummary(PokemonSelected)
{

	//SUMMARY SCREEN: MOVES
	this.moves = function()
	{
		for (var i = 0; i < 10; i++)
		{
			var y = 50 + (MenuSpacing*i);
			TalkFont.drawText(100, y, PokemonSelected.moves[i]);
		}
		
		RenderStuff();	
		WaitForKey(KEY_CTRL);
	}
	
	
		var xr = 238;
	
		PokemonSummaryBack.blit(0, 0);
		
		//	Text at the top
		WhiteTalkFont.drawText(4, 2, "POKMON INFO");
		
		
		//	Text & image at the left part
		WhiteTalkFont.drawText(4, 21, "Lv" + PokemonSelected.level + "\t\t" + PokemonSelected.name);
		PokemonList[PokemonSelected.number].image = LoadImage("Pokemon/" + PokemonSelected.number + ".png");
		PokemonList[PokemonSelected.number].image.blit(50, 60);
		
		
		//	Stats at the right part
		TalkFont.drawText(xr, 23, PokemonSelected.number);
		TalkFont.drawText(xr, 38, PokemonSelected.name);
		
		if (PokemonSelected.type2 != "")
			TalkFont.drawText(xr, 53, PokemonSelected.type.toUpperCase() + ", " + PokemonSelected.type2.toUpperCase());
		else
			TalkFont.drawText(xr, 53, PokemonSelected.type.toUpperCase());
		
		//To be changed: original trainer
		TalkFont.drawText(xr, 68, PlayerName);
		
		//To be added: ID
		if (PokemonSelected.item != undefined && PokemonSelected.item != "")
		 TalkFont.drawText(xr, 98, PokemonSelected.item.name);
		
		//Trainer memo at the bottom
		TalkFont.drawTextBox(8, 158, 180, 35, 0, PokemonSelected.nature + " nature." +
		"\nMet in " + PokemonSelected.FindPlace + " at Lv " + PokemonSelected.FindLevel + ".");
		
		
		//Yellow stats.
		TalkFont.drawText(240, 118, PokemonSelected.HP + "/" + PokemonSelected.maxHP);
		TalkFont.drawText(275, 136, PokemonSelected.attack);
		TalkFont.drawText(275, 149, PokemonSelected.defense);
		TalkFont.drawText(275, 162, PokemonSelected.special_attack);
		TalkFont.drawText(275, 175, PokemonSelected.special_defense);
		TalkFont.drawText(275, 187, PokemonSelected.speed);
		
		//Exp. stats
		var MeterWidth = 100;
		
		TalkFont.drawText(147, 208, "EXP. POINTS");
		TalkFont.drawText(147, 220, "NEXT LV.");
		
		TalkFont.drawText(240, 208, PokemonSelected.experience);
		TalkFont.drawText(240, 220, PokemonSelected.exp_to_next_level);
		
		
		RenderStuff();
		
		if (GetKey() == KEY_RIGHT) this.moves();
		
		WaitForKey(KEY_CTRL);
}
