//SaveGame.js
//The load and save game system

var slot = undefined;



//============================
//					GAME SAVING
//============================

function SaveGame()
{
	TextBox("Please select a save slot.");
	TextBox("The slot you choose will be used in the future for this savegame.");
	Delay(250);
	
	var SelectSlot = new Array();
	var LoadNames = OpenFile("names.sav");
	
	SelectSlot[0] = LoadNames.read("name1", "EMPTY");
	SelectSlot[1] = LoadNames.read("name2", "EMPTY");
	SelectSlot[2] = LoadNames.read("name3", "EMPTY");
	SelectSlot[3] = LoadNames.read("name4", "EMPTY");
	
	var x = SW/3;
	var y = SH/3;
	var w = 120;
	
	mFont = MenuFont;
	Menu(x, y, w, SelectSlot);
	slot = Menu.result;
	
	if (slot == undefined)
		return;
	
	//Game is going to be saved?
	if (slot != undefined)
		YesNoQuestion("Overwrite old game?\n(Game is only partly saved!)");
	
	if (YesNoQuestion.answer)
	{
		//A temp to save under the name 'slot number' + player name
		var text = (slot+1) + " - " + Player.Name;
		
		var test = "name" + (slot+1);
		LoadNames.write("name" + (slot+1), text);
		
		var PreviousSpeed = TextBox.speed;
		TextBox.speed = TextSlow;
		
		TextBox.getKey = false;
		TextBox.playsound = false;
		TextBox.arrow = false;
		TextBox.surface = true;
		TextBox("Saving the game, do not close down the program!");
		
		
		
		///////////////////////////////////////
		//				SAVING THE GAME
		///////////////////////////////////////
		
		//Save general stuff.
		//==============================
		var SaveFile = OpenFile("slot" + slot + "/save.sav");
		
		SaveFile.write("PlayerName", Player.Name);
		SaveFile.write("PlayerID", Player.ID);
		SaveFile.write("PlayerGender", Player.gender);
		SaveFile.write("PlayerBadges", Player.badges);
		SaveFile.write("CurrentMap", GetCurrentMap());
		SaveFile.write("MapX", GetPersonX("MainPerson"));
		SaveFile.write("MapY", GetPersonY("MainPerson"));
		SaveFile.write("TextSpeed", TextSpeed);
		
		SaveFile.write("MotherSave", Player.motherSave);
		SaveFile.write("SaveAmount", Player.saveAmount);
		SaveFile.write("money", Player.money);
		
		SaveFile.write("PlayerPokemon", PlayerPokemon.length);
		
		SaveFile.flush();
				
		
		//Music. Important, and music saving/loading now WORKS thanks to
		//FutureBoyNil and Setain! Thanks guys!
		SaveFile.write("music", Game.music.filename);
		
		
		
		//Game events storing
		//==============================
		var EventFile = OpenFile("slot" + slot + "/events.sav");
		
		EventFile.write("MainStoryline", GameEvents["main"]);
		EventFile.write("Cherrygrove guide", GameEvents["Cherrygrove guide"]);
		EventFile.write("Route 30 berry man", GameEvents["Route 30 berry man"]);
		
		EventFile.flush();
		
		//EventFile.write(
		
		
		//Save Pokmon list
		//==============================
		for (var i = 0; i < PlayerPokemon.length; i++)
		{
			var SavePokemon = OpenFile("slot" + slot + "/PlayerPokemon" + i + ".sav");
			
			SavePokemon.write("name", PlayerPokemon[i].name);
			SavePokemon.write("nickname", PlayerPokemon[i].nickname);
			SavePokemon.write("gender", PlayerPokemon[i].gender);
			SavePokemon.write("number", PlayerPokemon[i].number);
			SavePokemon.write("type", PlayerPokemon[i].type);
			SavePokemon.write("type2", PlayerPokemon[i].type2);
			
			if (PlayerPokemon[i].item != undefined)
				SavePokemon.write("item", PlayerPokemon[i].item.name);
			
			SavePokemon.write("nature", PlayerPokemon[i].nature);
			SavePokemon.write("FindPlace", PlayerPokemon[i].FindPlace);
			SavePokemon.write("FindLevel", PlayerPokemon[i].FindLevel);
			SavePokemon.write("level", PlayerPokemon[i].level);
			SavePokemon.write("HP", PlayerPokemon[i].HP);
			SavePokemon.write("maxHP", PlayerPokemon[i].maxHP);
			SavePokemon.write("attack", PlayerPokemon[i].attack);
			SavePokemon.write("defense", PlayerPokemon[i].defense);
			SavePokemon.write("special_attack", PlayerPokemon[i].special_attack);
			SavePokemon.write("special_defense", PlayerPokemon[i].special_defense);
			SavePokemon.write("speed", PlayerPokemon[i].speed);
			SavePokemon.write("experience", PlayerPokemon[i].experience);
			SavePokemon.write("exp_to_next_level", PlayerPokemon[i].exp_to_next_level);
			SavePokemon.write("growspeed", PlayerPokemon[i].growspeed);
			SavePokemon.write("ability", PlayerPokemon[i].ability);
			SavePokemon.write("status", PlayerPokemon[i].status);
			SavePokemon.write("evolve_to", PlayerPokemon[i].evolve_to);
			SavePokemon.write("evolve_at_level", PlayerPokemon[i].evolve_at_level);
			
			SavePokemon.write("moves", PlayerPokemon[i].moves);		//Testing array saving...
			
			SavePokemon.write("OT", PlayerPokemon[i].OT);
			SavePokemon.write("ID", PlayerPokemon[i].ID);
			
			SavePokemon.flush();
		}
		
		//TO DO: box saving
		
		
		///////////////////////////////////////
		//					SAVING DONE
		///////////////////////////////////////
		
		//Stuff after shave, er, save
		Delay(1500);
		TextBox("Game saved!");
		Delay(1000);
		
		//Set values of TextBox back to their normal state.
		TextBox.getKey = true;
		TextBox.speed = PreviousSpeed;
		TextBox.playsound = true;
		TextBox.arrow = true;
		
		TextBox.surface = false;
		
		RenderMap();
	}
}




//============================
//				GAME LOADING
//============================

function LoadGame()
{
	
	var SelectSlot = new Array();
	var LoadNames = OpenFile("names.sav");
	
	TextBox("Select the game to load.");
	
	SelectSlot[0] = LoadNames.read("name1", "EMPTY");
	SelectSlot[1] = LoadNames.read("name2", "EMPTY");
	SelectSlot[2] = LoadNames.read("name3", "EMPTY");
	SelectSlot[3] = LoadNames.read("name4", "EMPTY");
	
	var x = SW/3;
	var y = SH/3;
	var w = 120;
	
	mFont = MenuFont;
	
	Menu(x, y, w, SelectSlot);
	slot = Result;
	
	if (Result == undefined)
		return;
	
	//If the slot is empty...
	if (SelectSlot[Result] == "EMPTY")
		TextBox("This file is empty.");
	
	
	//If slot isn't empty...
	if (SelectSlot[Result] != "EMPTY")
	{
		
		///////////////////////////////////////
		//				LOADING THE GAME
		///////////////////////////////////////
		
		TextBox.arrow = false;
		TextBox.getKey = false;
		TextBox.playsound = false;
		
		TextBox("Please wait.\nLoading game " + (slot+1) + "...");
		
		
		//Load general stuff.
		//==============================
		var SaveFile = OpenFile("slot" + slot + "/save.sav");
		
		Player.Name = SaveFile.read("PlayerName", Player.Name);
		Player.ID = SaveFile.read("PlayerID", Player.ID);
		Player.gender = SaveFile.read("PlayerGender", Player.gender);
		Player.badges = SaveFile.read("PlayerBadges", Player.badges);
		
		TextBox.speed = SaveFile.read("TextSpeed", TextSpeed);
		
		Player.motherSave = SaveFile.read("MotherSave", Player.motherSave);
		Player.savemount = SaveFile.read("SaveAmount", Player.saveAmount);
		Player.money = SaveFile.read("money", Player.money);
		
		
		
		//SaveFile.read(
		
		
		//Save the berry states!
		//==============================
		var BerryFile = OpenFile("slot" + slot + "/berries.sav");
		
		BerryFile.write("ListLength", BerryTreeList.length);
		
		for (var i = 0; i < BerryTreeList.length; i++)
			BerryFile.write("tree"+i, BerryTreeList[i]);
		
		
		
		//Game events storage
		//==============================
		var EventFile = OpenFile("slot" + slot + "/events.sav");
		
		GameEvents["main"] = 	EventFile.read("MainStoryline", GameEvents["main"]);
		
		GameEvents["Cherrygrove guide"] = EventFile.read("Cherrygrove guide", undefined);
		GameEvents["Route 30 berry man"] = EventFile.read("Route 30 berry man", undefined);
		
		//GameEvents[""] = EventFile.read(
		
		
		
		//Load the berry states!
		//==============================
		var BerryFile = OpenFile("slot" + slot + "/berries.sav");
		
		BerryTreeList = new Array();	//Reset the berry array!
		var BerriesInFile = BerryFile.read("ListLength", 0);
		
		for (var i = 0; i < BerriesInFile; i++)
			BerryTreeList[i] = BerryFile.read("tree"+i, undefined);
		
		
		
		//Load Pokmon list
		//==============================
		
		var PlayerPokemonAmount = SaveFile.read("PlayerPokemon", 0);
		
		if (PlayerPokemon[0] == undefined)
			PlayerPokemon[0] = new Pokemon();
		
		for (var i = 0; i < PlayerPokemonAmount; i++)
		{
			var SavePokemon = OpenFile("slot" + slot + "/PlayerPokemon" + i + ".sav");
			
			PlayerPokemon[i].name = SavePokemon.read("name", PlayerPokemon[i].name);
			PlayerPokemon[i].nickname = SavePokemon.read("nickname", PlayerPokemon[i].nickname);
			PlayerPokemon[i].gender = SavePokemon.read("gender", PlayerPokemon[i].gender);
			PlayerPokemon[i].number = SavePokemon.read("number", PlayerPokemon[i].number);
			PlayerPokemon[i].type = SavePokemon.read("type", PlayerPokemon[i].type);
			PlayerPokemon[i].type2 = SavePokemon.read("type2", PlayerPokemon[i].type2);
			
			//if (SavePokemon.read("item", undefined) != "")
				//PlayerPokemon[i].item.name = SavePokemon.read("item", PlayerPokemon[i].item.name);
			
			PlayerPokemon[i].nature = SavePokemon.read("nature", PlayerPokemon[i].nature);
			PlayerPokemon[i].FindPlace = SavePokemon.read("FindPlace", PlayerPokemon[i].FindPlace);
			PlayerPokemon[i].FindLevel = SavePokemon.read("FindLevel", PlayerPokemon[i].FindLevel);
			PlayerPokemon[i].level = SavePokemon.read("level", PlayerPokemon[i].level);
			PlayerPokemon[i].HP = SavePokemon.read("HP", PlayerPokemon[i].HP);
			PlayerPokemon[i].maxHP = SavePokemon.read("maxHP", PlayerPokemon[i].maxHP);
			PlayerPokemon[i].attack = SavePokemon.read("attack", PlayerPokemon[i].attack);
			PlayerPokemon[i].defense = SavePokemon.read("defense", PlayerPokemon[i].defense);
			PlayerPokemon[i].special_attack = SavePokemon.read("special_attack", PlayerPokemon[i].special_attack);
			PlayerPokemon[i].special_defense = SavePokemon.read("special_defense", PlayerPokemon[i].special_defense);
			PlayerPokemon[i].speed = SavePokemon.read("speed", PlayerPokemon[i].speed);
			PlayerPokemon[i].experience = SavePokemon.read("experience", PlayerPokemon[i].experience);
			PlayerPokemon[i].exp_to_next_level = SavePokemon.read("exp_to_next_level", PlayerPokemon[i].exp_to_next_level);
			PlayerPokemon[i].growspeed = SavePokemon.read("growspeed", PlayerPokemon[i].growspeed);
			PlayerPokemon[i].ability = SavePokemon.read("ability", PlayerPokemon[i].ability);
			PlayerPokemon[i].status = SavePokemon.read("status", PlayerPokemon[i].status);
			PlayerPokemon[i].evolve_to = SavePokemon.read("evolve_to", PlayerPokemon[i].evolve_to);
			PlayerPokemon[i].evolve_at_level = SavePokemon.read("evolve_at_level", PlayerPokemon[i].evolve_at_level);
			
			SavePokemon.read("moves", PlayerPokemon[i].moves);		//Testing array saving...
			
			SavePokemon.read("OT", PlayerPokemon[i].OT);
			SavePokemon.read("ID", PlayerPokemon[i].ID);
		}
		
		
		
		
		//TO DO: box loading
		
		
		
		
		
		
		MakePerson(Player.Name, Player.gender);		
		if (!IsMapEngineRunning()) CreatePerson("MainPerson", Player.sprite, false);
		SetPersonDirection("MainPerson", "south");
		
		
		///////////////////////////////////////
		//					LOADING DONE
		///////////////////////////////////////
		
		//Stuff after loading
		Delay(1000);
		TextBox("Game loaded!");
		Delay(1000);
		
		
		//Fade out, change the map, person position and music, and fade back in to the new map.
		FadeOut(8, 0, 0, 0);
		
		LoadScreen("Loading map...");
		
		var map = "";
		if (IsMapEngineRunning())
			map = GetCurrentMap(),
			ChangeMap(SaveFile.read("CurrentMap", map));
		
		else
			AttachCamera("MainPerson"),
			AttachInput("MainPerson");
			
		
		
		SetPersonX("MainPerson", SaveFile.read("MapX", GetPersonX("MainPerson")));
		SetPersonY("MainPerson", SaveFile.read("MapY", GetPersonY("MainPerson")));
		
		
		//Stop old music, play new music!
		if (Game.music != undefined) Game.music.stop();
		Game.music = LoadSound(SaveFile.read("music", ""));
		Game.music.play(true);
		
		
		FadeIn(8, 0, 0, 0);
		TextBox.getKey = true;
		TextBox.arrow = true;
		TextBox.playsound = true;
		
		if (!IsMapEngineRunning())
			Game.temp = [SaveFile.read("CurrentMap", map), SaveFile.read("MapX", GetPersonX("MainPerson")), SaveFile.read("MapY", GetPersonY("MainPerson")), "loaded"],
			MapEngine("LoadMap.rmp", 60)
	}
}
