//StandardFunctions.js

var Surface = GrabSurface(0,0,GetScreenWidth(),GetScreenHeight());
var SurfaceImage = Surface.createImage();

var FadeColor;



//First things first...
//DEBUG FUNCTIONS

//The thing that connects all debug functions.
function DebugMenu()
{
	Game.surface = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());
	var old = Menu.font;
	Menu.font = TalkFont;
	
	var options = new Array("Quickload", "Warp", "Set X/Y", "Check X/Y", "Game story +", "Game Story -");
	Menu(10, 10, 150, options);
	
	
	if (options[Menu.result] == "Quickload")
		slot = 0,
		LoadGame();
	
	else if (options[Menu.result] == "Warp")
		WarpMenu();
	
	else if (options[Menu.result] == "Set X/Y")
		ChooseXY();
	
	else if (options[Menu.result] == "Check X/Y")
		CheckXY();
	
	else if (options[Menu.result] == "Game story +")
		GameEvents["main"]++,
		TextBox("GameEvents main is now " + GameEvents["main"]);
	
	else if (options[Menu.result] == "Game Story -")
		GameEvents["main"]--,
		TextBox("GameEvents main is now " + GameEvents["main"]);
	
	
	
	Menu.font = old;
}




//Warp to any map.
function WarpMenu()
{
	var maps = GetFileList("maps");
	Menu(10, 10, 160, maps);
	
	if (Menu.result != undefined)
	{
		var Map = maps[Menu.result];
		
		var x = InputBox("Go to which X position?", 255);
		var y = InputBox("Go to which Y position?", 255);
		
		Warp(Map, x, y);
	}
}



//Set x and y.
function ChooseXY()
{
	var x = InputBox("Current X position is " + GetPersonTileX("MainPerson") + "\nGo to which X position?", 255);
	var y = InputBox("Current Y position is " + GetPersonTileY("MainPerson") + "\nGo to which Y position?", 255);
	
	SetPersonTileXY("MainPerson", x, y);
}



//Display tile x and y in tile and real values.
function CheckXY()
{
	TextBox("X tile: " + GetPersonTileX(GetInputPerson()) + "\nY tile: " + GetPersonTileY(GetInputPerson()));
	TextBox("Real X: " + GetPersonX(GetInputPerson()) + "Real Y: " + GetPersonY(GetInputPerson()));
}








//SetRenderScript() edited so I can add to it!

var OldSetRenderScript = SetRenderScript;

SetRenderScript = function(script)
{
	if (this.current == undefined) this.current = "";
	this.current += script;
	
	OldSetRenderScript(script);
}







function Warp(map, x, y, NewMusic)
{
	//Clear all movement commands.
	ClearTileMovement();	
	FinishTile();
	
	
	UpdateMapEngine();
	RenderMap();
	FlipScreen();
	
	FadeOut(8, 0, 0, 0);
	FlipScreen();
	LoadScreen("Loading map...");
	ChangeMap(map);
	
	SetPersonX("MainPerson", (x * 16) + 7);
	SetPersonY("MainPerson", (y * 16) + 7);
	
	UpdateMapEngine();		//Fix so the warp fade is focused on the player.
		
	Delay(100);
	SetDayNight();
	
	if (NewMusic != undefined && NewMusic != Game.music)
	{
		Game.music.stop();
		Game.music = NewMusic;
		Game.music.play(true);
	}
	
	FadeIn(8, 0, 0, 0);
}


function FadeOut(speed, R, G, B)
{
	if (IsMapEngineRunning()) RenderMap();
	var i = 0;
	var SW = GetScreenWidth();
	var SH = GetScreenHeight();
	FadeColor = CreateColor(R, G, B, i);
	
	for (i = 0; i < 255; i+=speed)
	{
		if (IsMapEngineRunning() && Game.machine == "fast")
			UpdateMapEngine();
		
		if (IsMapEngineRunning())
			RenderMap();
		
		FadeColor.alpha = i;
		Rectangle(0, 0, SW, SH, FadeColor);
		RenderStuff();
	}
	
	//Fix some flashy stuff at the load screen.
	Rectangle(0, 0, SW, SH, Black);
	FlipScreen();
}


function FadeIn(speed, R, G, B)
{
if (IsMapEngineRunning()) RenderMap();
var i = 255;
var SW = GetScreenWidth();
var SH = GetScreenHeight();
FadeColor = CreateColor(R, G, B, i);

for (i = 255; i > 0; i-=speed)
{
	if (IsMapEngineRunning())
		UpdateMapEngine(),
		RenderMap();
	
	FadeColor.alpha = i;
	Rectangle(0, 0, SW, SH, FadeColor);
	RenderStuff();
}
}


function Delay(milliseconds)
{
  var start = GetTime();
  while (start + milliseconds > GetTime())
  {
  }
}


function LoadScreen(thing_to_load)
{
	//Now improved! Works differently when map opened!
	font = MenuFont;
	
	var TempColor = CreateColor(0, 0, 0, 10);
	if (FadeColor != undefined && FadeColor.alpha < 200)
	{
		UpdateMapEngine();
		RenderMap();
		var background = GrabImage(0, 0, SW, SH);
		background.blit(0, 0);
		Rectangle(0, 0, SW, SH, TempColor);
		
		LoadBackWindow.drawWindow(220, 5, 95, 40);
		
		var x = 260;
		var y = 10;
		font.setColorMask(BrightRed);
		font.drawText(x, y, "Loading");
		
		TalkFont.setColorMask(White);
		x = 312 - TalkFont.getStringWidth(thing_to_load);
		y = 27;
		TalkFont.drawText(x, y, thing_to_load);
		
		FlipScreen();
		Font = LoadFont("talkfont.rfn");
		font = Font;
	}
	
	else
	{
		var x = (GetScreenWidth() / 2) - font.getStringWidth("Loading");
		var y = GetScreenHeight() / 3;
		font.setColorMask(BrightRed);
		font.drawZoomedText(x, y, 2, "Loading");
		
		font.setColorMask(White);
		x = (GetScreenWidth() / 2) - (font.getStringWidth(thing_to_load) / 2);
		y = GetScreenHeight() / 2;
		font.drawText(x, y, thing_to_load);
		
		FlipScreen();
		Font = LoadFont("talkfont.rfn");
		font = Font;
	}
	
}


function WalkToMap(map, x, y, NewMusic)
{
	ClearTileMovement();	
	FinishTile();
	
	//Change the fade color if it doesn't exist yet. (Bug fix for walking to map before ever having faded)
	if (FadeColor == undefined)
		FadeColor = CreateColor(0, 0, 0, 10);
	
	LoadScreen("Loading Map...");
	ChangeMap(map);
	
	SetPersonX("MainPerson", (x * 16) + 7);
	SetPersonY("MainPerson", (y * 16) + 7);
	
	SetDayNight();
	
	if (NewMusic != undefined)
	{
		Game.music.stop();
		Game.music = NewMusic;
		Game.music.play(true);
	}
}




//Not used?
function TurnPerson(name, dir, delay)
{
	SetPersonDirection(name,dir);
	if (IsMapEngineRunning()) RenderMap();
	FlipScreen();
	Delay(delay);
}



function FacePlayer(person)
{
	//Now improved! Automatically checks who to turn! But if a parameter is inserted, it uses this one instead!
	//Improved some more: the main person is now checked with GetInputPerson() instead of always the MainPerson.
	
	if (person == undefined) var person_to_turn = GetCurrentPerson();
	else var person_to_turn = person;
	
	var InputPerson = GetInputPerson();

	if (GetPersonDirection(InputPerson) == "north")
		SetPersonDirection(person_to_turn, "south");
	
	else if (GetPersonDirection(InputPerson) == "south")
		SetPersonDirection(person_to_turn, "north");
	
	else if (GetPersonDirection(InputPerson) == "east")
		SetPersonDirection(person_to_turn, "west");
	
	else if (GetPersonDirection(InputPerson) == "west")
		SetPersonDirection(person_to_turn, "east");
}






//MapWait is a function that just waits a while, showing the map.
//Um... I have Wait() now, though this one does it a tiny bit different.
function MapWait(time_amount)
{
	for (var time = 0; time < time_amount; time++)
	{
		UpdateMapEngine();
		RenderMap();
		FlipScreen();
		Delay(400/GetMapEngineFrameRate());
	}
}




//StartComputer() starts the computer. This may go in a new script file later.
function StartComputer()
{
	sComputerOn.play(false);
	TextBox("The computer won't start, weird...");
	TextBox("It's probably because DaVince didn't create the code for the computer yet.\nToo bad.");
}




//The walk function for CUTSCENES ONLY!
function StoryWalk(person, direction, amount)
{
	
	//Amount of tiles to walk
	for (var n = 0; n < amount; n++)
	{
	
		//Walk the tile!
		for (var i = 0; i < GetTileHeight(); ++i)
		{
			if (direction == "north")
			{
				SetPersonDirection(person, "north");
				QueuePersonCommand(person, COMMAND_MOVE_NORTH, false);
			}
			
			else if (direction == "south")
			{
				SetPersonDirection(person, "south");
				QueuePersonCommand(person, COMMAND_MOVE_SOUTH, false);
			}
			
			else if (direction == "east")
			{
				SetPersonDirection(person, "east");
				QueuePersonCommand(person, COMMAND_MOVE_EAST, false);
			}
			
			else if (direction == "west")
			{
				SetPersonDirection(person, "west");
				QueuePersonCommand(person, COMMAND_MOVE_WEST, false);
			}
			
			
			//Addition to make it block anything following until done.
			//Thanks to Vexo at Spheredev.net for this!
			var last = GetTime();
			var delay = 500/GetMapEngineFrameRate();
			while(!IsCommandQueueEmpty(person) && IsMapEngineRunning())
			{
				if(GetTime() > last + delay)
				{
					UpdateMapEngine();
					RenderMap();
					FlipScreen();
					last = GetTime();
					}
			}
			
		}
	}
}



//Just like Delay, escept the map engine keeps being updated.
function Wait(milliseconds)
{
  var start = GetTime();
  while (start + milliseconds > GetTime())
  {
		UpdateMapEngine();
		RenderMap();
		FlipScreen();
  }
}





//Deposit / withdraw money system
function MoneySelect(mode, MaxWithdraw)
{
	ClearTileMovement();
	
	Font = TalkFont;
	
	var x = 135;
	var y = 185 + MenuSpacing;
	Height = 42;
	Width = GetScreenWidth() - (35 * 2);
		
	var digit = new Array(0, 0, 0, 0, 0, 0);
	var done = false;
	
	var xselect = 0;
	
	while (!done)
	{
		Window.drawWindow(x - 100, y - MenuSpacing, Width, Height);
		Rectangle((x-2) + (12*xselect), y-2, 10, 13, Transparent(Grey, 150));
		
		//Draw the digits on the screen.
		for (var i = 0; i < 6; i++)
			Font.drawText(x + (12*i), y, digit[i]);
		
		RenderStuff();
		
		//CHECK KEY PRESSES
		//Selecting a digit.
		GetKey();
		
		beep.stop();
		beep.play(false);
		
		if (IsKeyPressed(KEY_LEFT) && xselect > 0)
			xselect--;
		
		else if (IsKeyPressed(KEY_RIGHT) && xselect < 5)
			xselect++;
		
		
		//Selecting a value for the current digit.
		else if (IsKeyPressed(KEY_UP) && digit[xselect] < 9)
			digit[xselect]++;
		
		else if (IsKeyPressed(KEY_DOWN) && digit[xselect] > 0)
			digit[xselect]--;
		
		
		//Let's see what the value is.
		var value = digit[0]*100000 + digit[1]*10000 + digit[2]*1000 + digit[3]*100 + digit[4]*10 + digit[5];
		
		
		//Confirming
		if (IsKeyPressed(KEY_CTRL))
		{
			//Check mode & allowed
			if (mode == "withdraw" && value > MaxWithdraw)
				TextBox("You can't take this much money.");
			
			else if (mode == "withdraw" && value <= MaxWithdraw)
			{
				Player.money += value;
				MaxWithdraw -= value;
				TextBox("$" + value + " withdrawn.")
				done = true;
			}
			
			else if (mode == "deposit" && value >= Player.money)
				TextBox("You can't deposit this much money.");
			
			else if (mode == "deposit" && value <= Player.money)
			{
				Player.money -= value;
				MaxWithdraw += value;
				TextBox("$" + value + " deposited.")
				done = true;
			}
			
			else
				TextBox("'" + mode + "' is an invalid mode for MoneySelect(). \"withdraw\" or \"deposit\" are valid modes.");
		}
		
		//Cancel
		else if (IsKeyPressed(KEY_ALT))
			value = 0, done = true;
		
		//Don't forget to add or subtract 'result' from the variable used for MaxWithdraw.
		result = value;
		
	}
}




//Get the person's x tile.
function GetPersonTileX(name)
{
	var x = GetPersonX(name);
	var result = Math.round(x/GetTileWidth());
	return result;
}


//Get the person's y tile.
function GetPersonTileY(name)
{
	var x = GetPersonY(name);
	var result = Math.round(x/GetTileHeight());
	return result;
}




//SET the person's x AND y tile.
function SetPersonTileXY(name, x, y)
{
	SetPersonX(name, (x*16)+7);
	SetPersonY(name, (y*16)+7);
}





//Path walk code thanks to...

function GetFollowPathDelta(path, index)
{
	var delta = 0;
	if (index >= 0 && index < path.length) {
		switch (path.charAt(index)) {
			case "N": delta = GetTileHeight(); break;
			case "S": delta = GetTileHeight(); break;
			case "E": delta = GetTileWidth(); break;
			case "W": delta = GetTileWidth(); break;
			case "D": delta = Math.sqrt(GetTileWidth() * GetTileHeight()); break;
			case "F": delta = Math.sqrt(GetTileWidth() * GetTileHeight()); break;
		}
	}
	return delta;
}


function FollowPath(person_name, path)
{
  var path_state = 0;

  if ("list" in FollowPath == false)
  {
		FollowPath.list = new Object();
  }
  
  if (person_name in FollowPath.list == false) {
    FollowPath.list[person_name] = new Object();
    FollowPath.list[person_name].name = person_name;
    FollowPath.list[person_name].path = path;
    FollowPath.list[person_name].index = 0;
    FollowPath.list[person_name].delta = GetFollowPathDelta(path, 0);
  }

  if (FollowPath.list[person_name].path != path) {
    FollowPath.list[person_name].path = path;
    FollowPath.list[person_name].index = 0;
    FollowPath.list[person_name].delta = GetFollowPathDelta(path, 0);
  }

  if (FollowPath.list[person_name].delta == 0) {
    if (FollowPath.list[person_name].path.charAt(FollowPath.list[person_name].index) != "F")
      FollowPath.list[person_name].index++;
    FollowPath.list[person_name].delta = GetFollowPathDelta(path, FollowPath.list[person_name].index);
  }

  if (FollowPath.list[person_name].index >= path.length) {
    FollowPath.list[person_name].index = 0;
    FollowPath.list[person_name].delta = GetFollowPathDelta(path, FollowPath.list[person_name].index);
  }

  if (FollowPath.list[person_name].index >= 0 && FollowPath.list[person_name].index < path.length) {

    var dx = GetPersonX(person_name);
    var dy = GetPersonY(person_name);

    switch (FollowPath.list[person_name].path.charAt(FollowPath.list[person_name].index).toUpperCase()) {
      case "N": dy -= 1; QueuePersonCommand(person_name, COMMAND_FACE_NORTH, true); if (!IsPersonObstructed(person_name, dx, dy)) { QueuePersonCommand(person_name, COMMAND_MOVE_NORTH, false); FollowPath.list[person_name].delta--; path_state = 1; } break;
      case "S": dy += 1; QueuePersonCommand(person_name, COMMAND_FACE_SOUTH, true); if (!IsPersonObstructed(person_name, dx, dy)) { QueuePersonCommand(person_name, COMMAND_MOVE_SOUTH, false); FollowPath.list[person_name].delta--; path_state = 1; } break;
      case "E": dx += 1; QueuePersonCommand(person_name, COMMAND_FACE_EAST,  true); if (!IsPersonObstructed(person_name, dx, dy)) { QueuePersonCommand(person_name, COMMAND_MOVE_EAST, false);  FollowPath.list[person_name].delta--; path_state = 1; } break;
      case "W": dx -= 1; QueuePersonCommand(person_name, COMMAND_FACE_WEST,  true); if (!IsPersonObstructed(person_name, dx, dy)) { QueuePersonCommand(person_name, COMMAND_MOVE_WEST, false);  FollowPath.list[person_name].delta--; path_state = 1; } break;
      case "D": QueuePersonCommand(person_name, COMMAND_WAIT, false);  FollowPath.list[person_name].delta--; break;
      case "F": path_state = -1; break;
    }
  }

  return path_state;
}




function LocationText(place)
{
	SetTownText(place);
	SetRenderScript("RenderTownText()");
}



//Complete the tile before moving on.
function FinishTile()
{
	while (g_still_to_move > 0)
	{
		UpdateMapEngine();
		RenderMap();
		FlipScreen();
		Delay(500/GetMapEngineFrameRate());
	}
	
	UpdateMapEngine();
	RenderMap();
	FlipScreen();
	
	//NEW: also check if the person is EXACTLY on the tile. If not, correct.
	if (GetPersonTileX("MainPerson") / 16 != Math.round(GetPersonTileX("MainPerson") / 16))
		SetPersonX("MainPerson", (Math.round(GetPersonTileX("MainPerson")) * 16) + 7);
	
	if (GetPersonTileY("MainPerson") / 16 != Math.round(GetPersonTileY("MainPerson") / 16))
		SetPersonY("MainPerson", (Math.round(GetPersonTileY("MainPerson")) * 16) + 7);
}




//======================
//		BERRY MANAGEMENT
//======================

//The ID is route + tree number. Tree 1 in Route 29 = 291.
var BerryTreeList = new Array();


//Berry Tree.
function BerryTree(item, ID)
{
	Time = new Date();		//Reload Time so it contains the current time.
	TextBox("It's a fruit-bearing tree.");
	
	//Make a berry info on the spot if it wasn't there.
	if (BerryTreeList[ID] == undefined) BerryTreeList[ID] = false;
	
	if (BerryTreeList[ID] != Time.getDay())
	{
		TextBox("Hey! There's a(n) " + item.name + " here!");
		YesNoQuestion("Want to take the " + item.name + "?");
		
		//Give item and set day info.
		if (YesNoQuestion.answer == true)
		{
			AddItem(item, 1);
			BerryTreeList[ID] = Time.getDay();
			TextBox(PlayerName + " took the " + item.name + ".");
		}
		
		else TextBox("You left the " + item.name + " alone.");
	}
	
	//If the date was the same...
	else
	{
		TextBox("There's nothing here...");
	}
	
}








function Random(low, high)
{
  return ((Math.random()*(high-low))+low)
}








var RandomLooker = new Object();


function RandomLook(dirs, wait)
{
	//Only run when the textbox isn't running.
	if (!TextBox.active)
	{
		
		//Get if this random looker was initialized before. If not, set his counter to 0.
		if (RandomLooker[GetCurrentPerson()] == undefined)
			RandomLooker[GetCurrentPerson()] = 0;
		
		RandomLooker[GetCurrentPerson()]++;
		
		//If the counter reached the wait time, set his direction to something random.
		if (RandomLooker[GetCurrentPerson()] == wait)
		{
			RandomLooker[GetCurrentPerson()] = 0;
			var TheRandom = Math.round(Random(0, dirs.length-1));
			SetPersonDirection(GetCurrentPerson(), dirs[TheRandom]);
		}
	
	}
}









