/*
POKMON GOLDENSKY / SILVERSEA

Jirachi
 Graphics, mapping, map events, project starter

DaVince
 Project leader, scripting, additional mapping, storyline, events, overall help

L_S
 Test player
*/




//====================
//		THE ABSOLUTE PRE STUFF
//====================


//Thanks to FutureBoyNil and Setain for making this work!
var old_LoadSound = LoadSound;

LoadSound = function (filename,stream)
{
	var s = old_LoadSound(filename,stream);
	s.filename = filename;
	return s;
}






//====================
//Initialize Scripts
//====================

RequireScript("Colors.js");
RequireScript("Vars.js");

RequireScript("Pokemon.js");
CreatePokemonListing();

RequireScript("MakePerson.js");
RequireScript("Text.js");
RequireScript("Render.js");
RequireScript("Menu.js");
RequireScript("Items.js");
RequireScript("PokemonMenu.js");
RequireScript("Render.js");
RequireScript("DayNight.js");
RequireScript("Conversation.js");
RequireScript("SaveGame.js");
RequireScript("misc.js");

RequireScript("StandardFunctions.js")
RequireScript("Story.js");

RequireScript("battle.js");
RequireScript("battle_enemies.js");

RequireScript("tile_movement.js");

	

/*
--------------------------
Start of the game
--------------------------
*/

function game()
{
	LoadMoveStats();
	
	Player.motherSave = false;
	Player.saveAmount = 5000;
	Player.money = 250;
	
	
	//Tile movement! ^_^
	BindKey(KEY_UP,    "AddKey(KEY_UP)",    "RemoveKey(KEY_UP)");
	BindKey(KEY_DOWN,  "AddKey(KEY_DOWN)",  "RemoveKey(KEY_DOWN)");
	BindKey(KEY_LEFT,  "AddKey(KEY_LEFT)",  "RemoveKey(KEY_LEFT)");
	BindKey(KEY_RIGHT, "AddKey(KEY_RIGHT)", "RemoveKey(KEY_RIGHT)");
	
	BindKey(KEY_SHIFT, "StartRunning()", "StopRunning()");
	
	SetUpdateScript("UpdateTileMovement()");
		
	LoadScreen("Loading game stuff...");
	SetTalkActivationKey(KEY_CTRL);
	BindKey(KEY_ESCAPE, "gTownY = -40, gTownDeltaY = 0, MainMenu()", "");
	
	if (!DebugMode)
		Intro(),
		LoadScreen("Loading game stuff...");
	
	//Add item test
	AddItem(Potion, 3);
	AddItem(PokeBall, 5);
	
	
	//Gender chooser.
	if (!DebugMode)
	{
		var BoyGirl = new Array("BOY", "GIRL");
		TextBox("Are you a boy? Or are you a girl?");
		Menu(SW/3, SH/3, 75, BoyGirl);
		if (BoyGirl[Result] == "BOY") Gender = "male";
		if (BoyGirl[Result] == "GIRL") Gender = "female";
		
		Player.Name = InputBox("What's your name?", 12);
	}
	
	MakePerson(Player.Name, Gender);
	
	//MainPerson.rss is the spriteset for the main person!
	CreatePerson("MainPerson", Player.sprite, false);
	SetPersonDirection("MainPerson", "south");
	
	AttachInput("MainPerson");
	AttachCamera("MainPerson");
	
	SetPersonFrameRevert("MainPerson", 10);
	
	
	
	//Debug keys
	if (DebugMode)
	{
		BindKey(KEY_TAB, "DebugMenu()", "");
		
		BindKey(KEY_MINUS, "GameEvents[\"main\"]--, TextBox('GameEvents main is now ' + GameEvents[\"main\"])", "");
		BindKey(KEY_EQUALS, "GameEvents[\"main\"]++, TextBox('GameEvents main is now ' + GameEvents[\"main\"])", "");
		
		AddPokemon(1);
	}
	
	
	Game.music = MTown[1];
	Game.music.play(true);
	
	LoadScreen("Loading map...");
	MapEngine("NewBark_inside.rmp",60);
	//MapEngine("CherrygroveCity.rmp", 60);
}







//--------------------------
//		Intro
//--------------------------

function Intro()
{
	var frame = 1;
	var maxframes = 16;
	
	var y = 10;
	
	var gs_logo = LoadImage("intro/gs_logo.png");
	var ss_logo = LoadImage("intro/ss_logo.png");
	var pkmn_logo = LoadImage("intro/pkmn_logo.png");
	var back = LoadImage("intro/back.png");
	var copyright = LoadImage("intro/copyright.png");
	
	var image = new Array();
	
	var backX = 0;
	
	for (var i = 1; i <= maxframes; i++)
		image[i] = LoadImage("intro/" + i + ".png");
	
	while (!IsKeyPressed(KEY_CTRL))
	{
		backX+=2;
		if (backX > 160) backX = 2;
		
		back.blit(backX-160, 0);
		back.blit(backX, 0);
		back.blit(backX+160, 0);
		
		pkmn_logo.blit(90, y);
		gs_logo.blit(20, y+35);
		font.drawText(160, y+55, "/");
		ss_logo.blit(160, y+35);
		
		image[Math.round(frame)].blit(85, y+40);
		frame+=0.1;
		if (frame >= maxframes) frame = 1;
		
		font.drawText(160-(font.getStringWidth("Press ctrl")/2), 190, "Press ctrl");
		copyright.blit(160-(copyright.width/2), 210);
		
		FlipScreen();
	}
	
	
	while (IsKeyPressed(KEY_CTRL));
	
	
	var options = ["New game", "Load game", "Quit"];
	Menu(20, 20, 100, options);
	
	while (IsKeyPressed(KEY_CTRL));
	
	if (options[Menu.result] == "Load game")
		LoadGame(),
		Exit();
	
	if (options[Menu.result] == "Quit" || options[Menu.result] == undefined)
		Exit();
	
	
	Game.music = MNewGame;
	Game.music.play(true);
	
	BigTextBox("THE CONTROLS" +
				  "\n\nctrl - confirm, talk" + "\nalt - cancel" +
				  "\nshift - run" + "\nescape - menu" +
				  "\n\nThese controls will be made easier in the future.\n\nPress ctrl to continue");
	
	BigTextBox("Pokmon GoldenSky/SilverSea\nA GBA-style remake of Pokmon Gold and Silver\n\n" + 
					"A project by DaVince, Jirachi and DarkLeon. Made in 2005 and 2006.\n\n" +
					"www.spheredev.org/~dnaproduct\n\n" +
					"Pokmon is Copyright Nintendo and Game Freak."
					);
	
	BigTextBox("You might find a lot of things that are not there yet, or are just temporary replacements." +
				  " Don't mention it to us. We usually know about it." + 
				  "\n\nWhat we DO need to know is when you get an ERROR message. Then contact us and tell us what the error is!" +
				  "\n\nNow go enjoy the game! \n-DaVince");
	
	MNewGame.stop();
}




