//Story.js

//================================
//		STORY LINE
//================================


//=========================
//		GAME EVENTS
//=========================
//All game events are stored in an object.
//Events can be made/handled easily with GameEvents["event name"] !
//File saving isn't really a problem either. This object is saved in its entirety
//And the file will even stay smaller earlier in the game.
var GameEvents = new Object();

GameEvents["main"] = 0;		//THE MAIN STORYLINE COUNTER


function Event(event)
{
	this.running;		//Keeps info if an event is running.
	
	
	if (!Event.running)
	{
		Event.running = true;
		
		ClearPersonCommands("MainPerson");
		FinishTile();
		
		
		//=====================
		//		MAIN 0
		//		WALKING DOWN THE STAIRS AT HOME
		//=====================
		if (event == "home walking downstairs" && GameEvents["main"] < 1)
		{
			ClearTileMovement();
			StopRunning();
			
			Game.music.stop();
			Game.temp = Game.music;
			Game.music = music["guidance mom"];
			Game.music.play(true);
			
			Wait(250);
			SetPersonDirection("Mother", "north");
			Wait(250);
			TextBox("MOM: !");
			Wait(500);
			
			/*
			StoryWalk("Mother", "north", 1);
			SetPersonDirection("MainPerson", "south");
			StoryWalk("Mother", "north", 1);
			*/
			
			//TEMP UNTIL MOTHER'S WALKING ANIMATION EXISTS
			StoryWalk("MainPerson", "south", 2);
			
			Wait(200);
			
			TextBox("Oh, " + Player.Name + "! Our neighbour, PROFESSOR ELM, was looking for you.");
			TextBox("He said he wants you to do something for him.");
			Wait(300);
			
			TextBox("Oh! I almost forgot! Your POKMON GEAR is back from the repair shop.");
			TextBox("Here you go!");
			Wait(200);
			
			TextBox(Player.Name + " received a POKGEAR!");
			Wait(200);
			
			TextBox("That's your POKMON GEAR, or just POKGEAR.");
			TextBox("It's essential if you want to be a good trainer.");
			
			var days = Time.getDay();
			if (days == 1) days = "MONDAY";
			else if (days == 2) days = "TUESDAY";
			else if (days == 3) days = "WEDNESDAY";
			else if (days == 4) days = "THURSDAY";
			else if (days == 5) days = "FRIDAY";
			else if (days == 6) days = "SATURDAY";
			else if (days == 0) days = "SUNDAY";
			
			TextBox("Oh, and what day is it again?\n" + days + ", is it?");
			TextBox("Okay, thanks for reminding me. I forgot for a second...");
			Wait(200);
			
			YesNoQuestion("By the way, do you know how to use the PHONE (not available in this version)?");
			
			if (YesNoQuestion.answer == true)
				TextBox("Don't you just turn the POKGEAR on and select the PHONE icon?");
			
			if (YesNoQuestion.answer == false)
				TextBox("I'll read the instructions."),
				TextBox("Turn the POKGEAR on and select the PHONE icon.");
			
			TextBox("Phone numbers are stored in memory. Just choose the name of whom you want to call."),
			TextBox("Gee, isn't that convenient?");
			
			
			//StoryWalk("Mother", "south", 2);
			Wait(200);
			SetPersonDirection("Mother", "west");
			
			
			//Fade out music.
			for (var i = 255; i > 0; i--)
				Game.music.setVolume(i), Wait(1);
			
			//Turn music back to the previous tune.
			Game.music.stop();
			Game.music = Game.temp;
			Game.music.setVolume(255);
			Game.music.play(true);
			
			GameEvents["main"] = 1;
		}
		
		
		
		
		
		//=====================
		//		ELM TALK
		//		On various occasions.
		//=====================
		if (event == "Elm Talk")
		{
			FacePlayer();
			
			if (GameEvents["main"] == 2 && temp != "busy")
				TextBox("If a wild POKMON appears, let your POKMON battle it!");
			
			if (GameEvents["main"] > 2 && GameEvents["main"] < 6)
				TextBox("MR. POKMON goes everywhere and finds rarities."),
				TextBox("Too bad they're just rare and not very useful..."),
				TextBox(Player.Name + ", I'm counting on you!");
			
			
		}
		
		
		
		
		
		
		//=====================
		//		MAIN 1
		//		ENTERING ELM'S LAB FOR THE FIRST TIME
		//=====================
		if (event == "enter Elm's lab 1a" && GameEvents["main"] == 1)
		{
			ClearTileMovement();
			StopRunning();
			
			StoryWalk("MainPerson", "north", 8);
			Wait(200);
			SetPersonDirection("Elm", "east");
			SetPersonDirection("MainPerson", "west");
			Wait(200);
			
			TextBox("ELM: " + Player.Name + "! There you are! I need to ask you a favour.");
			TextBox("I have an acquaintance called MR. POKMON. He keeps finding weird things and he likes");
			TextBox("to rave about his discoveries.");
			TextBox("Anyway, I just got an email from him saying that this time it's for real.");
			TextBox("It is intruiging, but we're too busy with our POKMON research.");
			TextBox("So could you look into it for us? I'll give you a POKMON for a partner.");
			TextBox("We have three POKMON available. They're all rare POKMON we found only recently.");
			TextBox("Go on. Pick one from the table!");
			
			//Because not all data is fileld in yet...
			TextBox("Oh, I almost forgot. You won't get the POKMON that are SUPPOSED to be the");
			TextBox("starters because a lot of POKMON data hasn't been filled in yet...");
			Wait(300);
			
			GameEvents["main"] = 2;
		}
		
		
		
		
		//=====================
		//		MAIN 2
		//		ENTERING ELM'S LAB FOR THE FIRST TIME - Continued after picking a Pokmon
		//=====================
		if (event == "enter Elm's lab 1b" && GameEvents["main"] == 2)
		{
			StopRunning();
			//ClearTileMovement();
			
			temp = "busy";
			
			var text = "ELM: You'll take ";
			
			//Add Pokmon names + info
					 if (Game.temp == 1) text += "BULBASAUR, the grass POKMON?";
			else if (Game.temp == 2) text += "CHARMANDER, the fire POKMON?";
			else if (Game.temp == 3) text += "SQUIRTLE, the water POKMON?";
			
			YesNoQuestion(text);
			
			if (YesNoQuestion.answer == false)
			{
				TextBox("Think it over carefully.\nYour partner is important.");
				Event.running = false;
				return;
			}
			
			//Option was apparently true because the event didn't return:
			TextBox("I think that's a great POKMON too!");
			
					 if (Game.temp == 1) text = "BULBASAUR";
			else if (Game.temp == 2) text = "CHARMANDER";
			else if (Game.temp == 3) text = "SQUIRTLE";
			
			TextBox(Player.Name + " received " + text + "!");
			
			
			//REALLY ADD THE POKMON TO THE PlayerPokemon HERE
			//TO DO: FIND CORRECT POKDEX VALUES FOR THE 3 POKMON
					 if (Game.temp == 1) AddPokemon(1);
			else if (Game.temp == 2) AddPokemon(4);
			else if (Game.temp == 3) AddPokemon(7);
			
			
			YesNoQuestion("Give a nickname to the " + text + " you received?");
			if (YesNoQuestion.answer)
				TextBox("Nickname giving is not available in this version of Pokmon GS/SS, sorry.");
			
			
			//Walk back to Elm. Check positions for accurate end positioning of the player.
			var XtoWalk = GetPersonTileX("MainPerson") - GetPersonTileX("Elm");
			var YtoWalk = GetPersonTileY("MainPerson") - GetPersonTileY("Elm");
			
			StoryWalk("MainPerson", "west", XtoWalk);
			SetPersonDirection("Elm", "south");
			StoryWalk("MainPerson", "north", YtoWalk);
			
			Wait(250);
			TextBox("MR. POKMON lives near CHERRYGROVE CITY, the next city from this one.");
			TextBox("It's almost a direct route to there.");
			
			Wait(200);
			SetPersonDirection("Elm", "west");
			Wait(200);
			TextBox("If your POKMON is hurt, you should heal it with this machine.");
			
			Wait(200);
			SetPersonDirection("Elm", "south");
			Wait(200);
			
			TextBox("Oh, here's my phone number. Call me if something comes up.");
			TextBox(Player.Name + " gets ELM's phone number.");
			TextBox("You can't call anyone in this version of Pokmon GS/SS though.");
			
			GameEvents["main"] = 3;
			
			temp = undefined;
		}
		
		
		
		
		//=====================
		//		MAIN 3
		//		ELM'S AIDE GIVES A POTION AFTER EVENT 2
		//=====================
		if (event == "Elm's Aide 1" && GameEvents["main"] == 3)
		{
			ClearTileMovement();
			StopRunning();
			
			Wait(250);
			var XtoWalk = GetPersonTileX("MainPerson") - GetPersonTileX("Aide");
			var YtoWalk = (GetPersonTileY("Aide") - GetPersonTileY("MainPerson")) - 1;
			
			StoryWalk("Aide", "east", XtoWalk);
			Wait(250);
			StoryWalk("Aide", "north", YtoWalk);
			
			TextBox(Player.Name + ", I want you to have this for your errand.");
			
			TextBox(Player.Name + " received a POTION!");
			AddItem("Potion", 1);
			TextBox(Player.Name + " put the POTION in the item pocket.");
			
			TextBox("There are only two of us, so we're always busy.");
			
			GameEvents["main"] = 4;
		}
		
		
		
		
		
		
		//=====================
		//		LEAVING NEW BARK TOO SOON
		//=====================
		if (event == "CheckLeaveNewBark" && GameEvents["main"] < 4)
		{
			ClearTileMovement();
			StopRunning();
			
			TextBox("WOMAN: Hold it!");
			StoryWalk("woman1", "west", 6);
			TextBox("WOMAN: It's dangerous to go out without POKMON!");
			StoryWalk("woman1", "east", 6);
			StoryWalk("MainPerson", "east", 3);
		}
		
		
		else if (event == "CheckLeaveNewBark" && GameEvents["main"] >= 4)
			WalkToMap("Route29.rmp", 70, Game.temp[0], MRoute[29]);
		
		
		
		
		
		
		//=====================
		//		CHERRYGROVE: OLD MAN GUIDES
		//=====================
		if (event == "Cherrygrove guide" && GameEvents["Cherrygrove guide"] != true)
		{
			ClearTileMovement();
			StopRunning();
			
			TextBox("You're a rookie trainer, aren't you? I can tell!");
			TextBox("That's OK! Everyone is a rookie at some point!");
			
			
			YesNoQuestion("If you'd like, I can teach you a few things.");
			
			if (YesNoQuestion.answer == false)
			{
				TextBox("Oh... It's something I enjoy doing...");
				TextBox("Fine. Come see me when you like.");
				return;
			}
			
			//Let's tour through Cherrygrove!
			else
			{
				TextBox("OK, then! follow me!");
				TextBox("(Note to player: I KNOW the follow movement is buggy, lol.)");
				
				
				//Check where the player is and move him to the bottom of the guy.
				//Person is at the left of the old guy
				if (GetPersonTileX("MainPerson") == 41)
					StoryWalk("MainPerson", "south", 1),
					StoryWalk("MainPerson", "east", 1);
				
				//Person is at the right of the old guy
				else if (GetPersonTileX("MainPerson") == 43)
					StoryWalk("MainPerson", "south", 1),
					StoryWalk("MainPerson", "west", 1);
				
				//Else, the player is at the bottom, which should be.
				
				Game.music.stop();
				var OldMusic = Game.music;
				Game.music = LoadSound("Music/DaVince/guide.it")
				Game.music.play(true);
				
				
				//Walk to PC
				FollowPerson("MainPerson", GetCurrentPerson(), 16);
					StoryWalk(GetCurrentPerson(), "west", 2);
					StoryWalk(GetCurrentPerson(), "north", 1);
					StoryWalk(GetCurrentPerson(), "west", 1);
				FollowPerson("MainPerson", "", 0);
				
				SetPersonDirection(GetCurrentPerson(), "north");
				SetPersonDirection("MainPerson", "north");
				
				TextBox("This is a POKMON CENTER. They heal your POKMON in no time at all.");
				TextBox("You'll be relying on them a lot, so you better learn about them.");
				
				
				//Walk to Mart
				FollowPerson("MainPerson", GetCurrentPerson(), 16);
					StoryWalk(GetCurrentPerson(), "west", 6);
				FollowPerson("MainPerson", "", 0);
				
				SetPersonDirection(GetCurrentPerson(), "north");
				SetPersonDirection("MainPerson", "north");
				
				TextBox("This is a POKMON MART.");
				TextBox("They sell BALLS for catching wild POKMON and other useful items.");
				
				
				//Walk to Route 30
				FollowPerson("MainPerson", GetCurrentPerson(), 16);
					StoryWalk(GetCurrentPerson(), "west", 7);
				FollowPerson("MainPerson", "", 0);
				
				SetPersonDirection(GetCurrentPerson(), "north");
				SetPersonDirection("MainPerson", "north");
				
				TextBox("ROUTE 30 is out this way. Trainers will be battling their prized POKMON there.");
				
				
				//Walk to beach
				FollowPerson("MainPerson", GetCurrentPerson(), 16);
					StoryWalk(GetCurrentPerson(), "west", 4);
					StoryWalk(GetCurrentPerson(), "south", 1);
					StoryWalk(GetCurrentPerson(), "west", 2);
					StoryWalk(GetCurrentPerson(), "south", 1);
				FollowPerson("MainPerson", "", 0);
				
				SetPersonDirection(GetCurrentPerson(), "west");
				SetPersonDirection("MainPerson", "west");
				
				TextBox("This is the sea, as you can see. Some POKMON are only found in water.");
				
				
				
				//Walk to old man's house
				FollowPerson("MainPerson", GetCurrentPerson(), 16);
					StoryWalk(GetCurrentPerson(), "south", 2);
					StoryWalk(GetCurrentPerson(), "east", 10);
					StoryWalk(GetCurrentPerson(), "south", 2);
					StoryWalk(GetCurrentPerson(), "east", 4);
				FollowPerson("MainPerson", "", 0);
				
				SetPersonDirection(GetCurrentPerson(), "west");
				
				
				
				TextBox("Here...");
				TextBox("It's my house! Thanks for your company. Let me give you a small gift.");
				
				TextBox(Player.Name + " will receive a MAP CARD here in the future!");
				TextBox(Player.Name + "'s POKGEAR now has a MAP!");
				TextBox("POKGEAR becomes more useful as you add CARDS.");
				TextBox("I wish you luck on your journey!");
				
				StoryWalk(GetCurrentPerson(), "north", 2);
				DestroyPerson(GetCurrentPerson());
				
				
				Game.music.stop();
				Game.music = OldMusic;
				Game.music.play(true);
				
				FinishTile();
				
				GameEvents["Cherrygrove guide"] = true;
			}
		}
		
		
		
		
		
		
		
		//=====================
		//		BERRY MAN
		//		To the rescue!
		//=====================
		if (event == "Route 30 berry man" && GameEvents["Route 30 berry man"] != true)
		{
			ClearTileMovement();
			StopRunning();
			
			TextBox("You know, POKMON eat berries.");
			TextBox("Well, my POKMON got healthier by eating a berry.");
			TextBox("Here. I'll share one with you too!");
			
			AddItem(berries.berry, 1);
			TextBox(""+ Player.Name +" received BERRY.");
			
			TextBox(Player.Name + " put the BERRY in the ITEM POCKET.");
			TextBox("Check trees for BERRIES. They just drop right off.");
			
			GameEvents["Route 30 berry man"] = true;
		}
		
		
		else if (event == "Route 30 berry man" && GameEvents["Route 30 berry man"] == true)
			TextBox("Check trees for BERRIES. They just drop right off.");
		
		
		
		
		
		//=====================
		//		MAIN 4
		//		MR. POKMON - MYSTERY EGG
		//=====================
		if (event == "Mr. Pokemon" && GameEvents["main"] == 4)
		{
			CreatePerson("Oak", "Fat_man.rss", true);
			SetPersonTileXY("Oak", 17, 17);
			
			ClearTileMovement();
			StopRunning();
			
			Wait(250);
			SetPersonDirection("Mr Pokemon", "south");
			Wait(250);
			TextBox("MR. POKMON: Hello, Hello! You bust be " + Player.Name + ".\nPROF. ELM said that you would visit.");
			StoryWalk("MainPerson", "north", 1)
			TextBox("This is what I want PROF. ELM to examine.");
			
			Wait(250);
			//Get item tune
			TextBox(Player.Name + " received MYSTERY EGG.");
			TextBox(Player.Name + " put the MYSTERY EGG in the KEY POCKET.");
			
			Wait(250);
			TextBox("I know a couple who run a POKMON DAY-CARE service. They gave me that EGG.");
			TextBox("I was intrigued, so I sent mail to PROF. ELM.");
			TextBox("For POKMON evolution, PROF. ELM is the authority.");
			TextBox("Even PROF. OAK here recognizes that.");
			
			//"If my assumption is correct, PROF. ELM will know it.");
			
			Wait(150);
			SetPersonDirection("Oak", "west");
			Wait(150);
			StoryWalk("Oak", "south", 1);
			Wait(150);
			SetPersonDirection("MainPerson", "east");
			StoryWalk("Oak", "west", 2);
			SetPersonDirection("MainPerson", "south");
			StoryWalk("Oak", "west", 2);
			SetPersonDirection("MainPerson", "west");
			StoryWalk("Oak", "north", 1);
			SetPersonDirection("Oak", "east");
			
			Wait(250);
			TextBox("OAK: Aha! So you're " + Player.Name + "!\nI'm OAK! A POKMON researcher.");
			TextBox("I was just visiting my old friend MR. POKMON.");
			TextBox("I heard you where running an errand for PROF. ELM, so I waited here.");
			TextBox("Oh! What's this? A rare pokemon!\nLet's see...");
			
			Wait(500);
			
			TextBox("Hm, I see!");
			TextBox("I understand why PROF. ELM gave you a pokemon for this errand.");
			TextBox("To researchers like PROF. ELM and I, POKMON are our friends. He saw that");
			TextBox("you would treat your pokemon with love and care.");
			Wait(250);
			
			TextBox("...Ah!");
			TextBox("You seem to be dependable. How would you like to help me out?");
			TextBox("See? This is the latest version of POKDEX. It automatically records data on POKMON");
			TextBox("you've seen or caught.\nIt's a hi-tech encyclopedia!");
			
			Wait(250);
			//Big get item tune
			TextBox("GUY received POKDEX!");
			
			Wait(250);
			TextBox("Go meet many kinds of POKMON and complete that POKDEX!");
			TextBox("But I've stayed too long. I have to get to GOLDENROD for my usual radio show.");
			TextBox(Player.Name + ", I'm counting on you!");
			
			Wait(150);
			StoryWalk("Oak", "south", 1);
			Wait(150);
			StoryWalk("Oak", "east", 1);
			Wait(150);
			StoryWalk("Oak", "south", 1);
			//Door sound?
			DestroyPerson("Oak");
			
			SetPersonDirection("MainPerson", "north");
			TextBox("MR POKMON: You are Returning to PROF. ELM?\nHere. Your pokemon should have some rest.");
			
			Wait(250);
			//Heal stuff here
			TextBox("[This is where the Pokmon will heal]");
			
			TextBox("I'm depending on you!");
			
			GameEvents["main"] = 5;
		}
		
		
		//if (event == "Mr. Pokemon" && GameEvents["main"] > 4 && GameEvents["main"] < 10)
			//TextBox("I'm depending on you!");
		
		//Any further events with Mr. Pokey go here!
		
		
		
		
		
		//=====================
		//		MAIN 5
		//		PHONE CALL OUTSIDE MR. POKMON'S HOUSE ABOUT SOMETHING IN ELM'S LAB
		//=====================
		if (event == "Phone: stolen Pokemon" && GameEvents["main"] == 5)
		{
			ClearTileMovement();
			StopRunning();
			
			sound["phone"].play(false);
			Wait(2000);
			TextBox("ELM: H-hello? " + Player.Name + "? It's a disaster.\nUh, um, it's just terrible!");
			TextBox("What should I do? It... Oh, no...\nPlease get back here now!");
			TextBox("Click!");
				//Play phone done sound here
			TextBox("..... .....\n..... .....");
			
			GameEvents["main"] = 6;
		}
		
		
		
		
		//=====================
		//		MAIN 6
		//		ENCOUNTERING THE RIVAL
		//=====================
		if (event == "Rival Encounter 1" && GameEvents["main"] == 6)
		{
			ClearTileMovement();
			StopRunning();
			
			CreatePerson("Rival", "Kamon.rss", true);
			SetPersonTileXY("Rival", 54, GetPersonTileY("MainPerson"));
			StoryWalk("Rival", "west", 9);
			
			TextBox("...");
			TextBox("You got a POKMON at the LAB. What a waste. A wimp like you.");
			TextBox("...Don't you get what I'm saying? Well, I too, have a good POKMON.");
			TextBox("I'll show you what I mean!");
			
			StupidBattle(Enemies["Rival Cherrygrove"]);
			
			TextBox("My name's ???. I'm going to be the world's greatest POKMON trainer.");
			
			
			//Move person up if he's on the lower tile, and else move him down.
			if (GetPersonTileY("MainPerson") == 17)
				StoryWalk("MainPerson", "north", 1);
			
			else
				StoryWalk("MainPerson", "south", 1);
			
			SetPersonDirection("MainPerson", "west");
			
			StoryWalk("Rival", "west", 4);
			StoryWalk("Rival", "north", 2);
			StoryWalk("Rival", "west", 10);
			DestroyPerson("Rival");
			
			
			
			//YOU WON!
			//WIN THE GAME
			//FINISHED IT!
			
			Game.music.stop();
			var OldMusic = Game.music;
			Game.music = LoadSound("Music/WonTrainer.it");
			Game.music.play(true);
			
			BigTextBox("Well, that's it folks! You've reached the end of POKMON GS/SS release 1!" +
			"\n\nWe hope you had fun playing this game. Give us suggestions if you have some!" +
			"\n\nThe DNA Productions team" + 
			"\nwww.spheredev.org/~dnaproduct");
			
			BigTextBox("CREDITS" + 
			"\n\nMaps & custom graphics\n Jirachi, DarkLeon" +
			"\n\nScripting & story\nDaVince" +
			"\n\nBeta testing\nL_S, DaVince, Jirachi, DarkLeon" +
			"\n\nTrainer Data\nPokemod" +
			"\n\nSpecial thanks to people from Nikos' Pokmon Forum!");
			
			BigTextBox("\nWell, that's it! Now you're free to walk through the game wherever you like!" +
			"\n\nStay tuned for release 2, which will have entirely recoded systems for more efficiency, less bugs," +
			"and things looking more towards the original Pokmon games!" +
			"\n\nI SAID I would release this today, hmm? Worked all day on it!" +
			"\n-DaVince");
			
			Game.music.stop();
			Game.music = OldMusic;
			Game.music.play(true);
			
			
			GameEvents["main"] = 7;
		}
		
		
		
		
		//=====================
		//		MAIN 7
		//		
		//=====================
		//if (event == "" && GameEvents["main"] == 0)
		
		
		
		
		//=====================
		//		MAIN 8
		//		
		//=====================
		//if (event == "" && GameEvents["main"] == 0)
		
		
		
		
		//=====================
		//		MAIN 9
		//		
		//=====================
		//if (event == "" && GameEvents["main"] == 0)
		
		
		
		
		//=====================
		//		MAIN 10
		//		
		//=====================
		//if (event == "" && GameEvents["main"] == 0)
		
		
		
		
	
		Event.running = false;
	}
}



Event.running = false;		//It isn't running by default.

