//Text.js
//Regulates text & text boxes.

//TextSpeed: the lower, the slower.
var TextSlow = 20;
var TextMedium = 10;
var TextFast = 5;

var TextSpeed = TextFast;



function WaitForKey(key)
{
while (true)
{
	GetKey();
	if (IsKeyPressed(key))
	{
		break;
	}
}
}




//The text box.
function TextBox(text)
{
	
	//EXTRA SETTINGS
	this.playsound;		//Should a sound be played at the end of the textbox?
	this.speed;				//What's the textbox' text blit speed?
	this.getKey;			//Should the textbox wait for a key before continuing?
	this.mapEngine;		//Should the map engine be blitted and animated?
	this.surface;			//Should the current surface be blitted?
	this.windowStyle;		//Which windowstyle should be used?
	this.font;				//Which font should be used?
	this.arrow;				//Should the arrow be displayed?
	this.active;
	
	TextBox.active = true;	//Is it active? True when starting!
	
	StopRunning();
	ClearTileMovement();
	
	var x = 35;
	var y = 185;
	Height = TextBox.font.getHeight() * 2;
	Width = GetScreenWidth() - (x * 2);
	
	
	var StringLength = text.length;
	var OutText = "";
	
	for (var s = 0; s <= StringLength; s++)
	{
		if (Game.machine == "fast")
			if (IsMapEngineRunning() && TextBox.mapEngine == true) UpdateMapEngine();
		
		if (IsMapEngineRunning() && TextBox.mapEngine == true)
			RenderMap();
		
		if (TextBox.surface)
			Game.surface.blit(0, 0);
		
		
		TextBox.windowStyle.drawWindow(x, y, Width, Height);
		OutText = text.slice(0, s);
		TextBox.font.drawTextBox(x, y, Width, Height, 0, OutText);
		
		if (TextBox.arrow)
			TextBox.font.drawText((x+Width)-10, y + 20, "^");
		
		Game.surface = GrabImage(0,0, SW, SH);
		
		FlipScreen();
		
		Delay(TextBox.speed);
	}
	
	//If Control key is skipped, you don't have to press control.
	//if (!SkipControl) WaitForKey(KEY_CTRL);
	
	while (!IsKeyPressed(KEY_CTRL) && TextBox.getKey)
	{
		if (IsMapEngineRunning() && TextBox.mapEngine == true)
			UpdateMapEngine(),
			RenderMap();
		
		if (TextBox.surface)
			Game.surface.blit(0, 0);
		
		TextBox.windowStyle.drawWindow(x, y, Width, Height);
		TextBox.font.drawTextBox(x, y, Width, Height, 0, text);
		
		if (TextBox.arrow)
			TextBox.font.drawText((x+Width)-10, y + 20, "^");
		
		FlipScreen();
		
		if (IsMapEngineRunning() && TextBox.mapEngine == true)
			Delay(700/GetMapEngineFrameRate());
	}
	
	
	//When you close the text box, the beep sound is played.
	//The first beep stop is there for fluent repeation when skipping through text boxes.
	if (TextBox.playsound)
		sound["beep"].stop(),
		sound["beep"].play(false);
	
	if (TextBox.getKey)
		GetKey();
	
	
	while (IsKeyPressed(KEY_CTRL) && TextBox.getKey);
	
	TextBox.active = false;		//Textbox isn't active anymore!
}




//SET A FEW DEFAULT SETTINGS FOR THE TEXTBOX
	TextBox.playsound = true;
	TextBox.speed = 3;
	TextBox.getKey = true;
	TextBox.mapEngine = true;
	TextBox.surface = false;
	TextBox.arrow = true;
	
	TextBox.windowStyle = TextWindow;
	TextBox.font = TalkFont;






function RenderStuff()
{
	//Store the last screen in the Game.surface.
	Game.surface = GrabImage(0, 0, SW, SH);
	
	FlipScreen();
	if (IsMapEngineRunning())
	{
		RenderMap();
	}
}




function BigTextBox(text)
{
	Width = SW - 30;
	Height = SH - 30;
	
	var CurrentSurface = GrabSurface(0, 0, GetScreenWidth(), GetScreenHeight());
	if (IsMapEngineRunning()) RenderMap();
	
	CurrentSurface.blit(0,0);
	BigWindow.drawWindow(15, 15, Width, Height);
	BigBoxBallPic.blit(Width - 40, Height - 37);
	TextBox.font.drawTextBox(17, 17, Width-2, Height-2, 0, text);
	RenderStuff();
	
	//Wait for key!
	while (!IsKeyPressed(KEY_CTRL));
	while (IsKeyPressed(KEY_CTRL));
}







//================
//INPUT BOX
//===========

function InputBox(question, limit)
{
	//Change TextBox settings.
	TextBox.getKey = false;
	TextBox.playSound = false;
	var OldStyle = TextBox.windowStyle;
	TextBox.windowStyle = PurpleWindow;
	
	var x = 35;
	var y = 130;
	var width = GetScreenWidth() - 70;
	var height = 40;
	
	var shift = false;
	var ShiftText = "lower case";
	var text = "";
	
	TextBox(question);
	
	while(true)
	{
		Game.surface.blit(0, 0);
		
		//Set shift text
		if (shift == false) ShiftText = "lower case";
		else ShiftText = "UPPER CASE";
		
		//The shift key box
		PurpleWindow.drawWindow(x, y - 25, width, 15);
		TextBox.font.drawTextBox(x, y - 25, width, 15, 1, ShiftText);
		
		//The actual input box
		PurpleWindow.drawWindow(x, y, width, height);
		TextBox.font.drawTextBox(x, y, width, height, 1, text + "_");
		
		FlipScreen();
		
		var key = GetKey();
		if (text.length < limit) text += GetKeyString(key, shift);
		
		//Check shift
		shift = false;
		if (key == KEY_SHIFT)
			shift = true;
		
		if (key == KEY_BACKSPACE)
			text = text.substr(0, text.length-1);
		
		if (key == KEY_ENTER && text != "")
			break;
	}
	
	
	//Revert TextBox settings.
	TextBox.getKey = true;
	TextBox.playSound = true;
	TextBox.windowStyle = OldStyle;
	
	
	return text;
	
}