//battle.js

	
	/*
	- Initialize enemy data and store it in a temp place.
	- Initialize own data, store the necessary ones in a temp place
	  (like ATK stat, so it can be changed in-battle).
	- Load stuff like the location, and maybe day/night.
	- Make the turn-based system:
		- Compare who has the fastest Pokemon in the current battle.
		- The one with the fastest will go first.
		
		- For the ally: make a menu. Each item will be linked to their respective functions
			(like change PKMN and the backpack). The fight item links to either another function
			specifically made for battle (would require data to be passed on and back), or exit
			from the menu loop and use an if to determine if the player was going to fight.
		- Make the move choose menu.
		- Look up in a database what the move does (just a script with some Sphere draw, wait,
			stat change commands) and run it.
		- End turn.
		
		- For the enemy: check the current Pokemon. Move data can be loaded either
			from file/script (hard), or it just loads the defaults for the Pokemon on this level
			and stats can be changed in the special parameter (easier).
		- Make a random 1-4 number generator to pick the move (don't forget empty moves).
		- Make the move.
		
		- After every turn (on both sides), a condition should check the state of the rivaling
			Pokemon.
			- If one's HP <= 0: let him faint.
			- If one has a status effect, affect it NOW and subtract one from its status effect var.
			- If the player or enemy doesn't have any usable Pokemon left: exit the turnbased loop
				and go to the win/white out screen.
		
	- Win screen: check out the enemy's experience data and add appropiate extra experience
		(like in trainer battles or using an exp item), load the money data if needed, and update
		the player's stats. Show the stuff on-screen too.
		- Save some data which determines you battled that specific person, if needed.
	- Lose screen: money/2 and return to the last Pokemon Center.
	*/


RequireScript("battle/moves.js");


var CurrentBattler;
var CurrentFoe;



/*
function TestBattle()
{
	AddPokemon(1);
	AddPokemon(2);
	AddPokemon(3);
	
	
	//When stats are inserted, let the battle begin!
	StartBattle(Enemies["New Bark Town"][0]);
}





function StartBattle(enemy, special)
{
	//MISC PREPARATIONS
	Game.music.stop();
	Game.music = LoadSound("Music/GSCTrainerBattle.mid");
	Game.music.play(true);
	
	
	//DRAW STUFF
	Game.surface = undefined;
	BattleBackground["cave1"].blit(0, 0);
	
	
	
	//Location and day/night loading here.
	
	
	//Fainted check to determine which Pokmon will fight first.
	//This also puts all of this Pokmon's stats in a new variable so it can be modified in-battle.
	for (var i = 0; i < PlayerPokemon.length; i++)
	{
		//Healthy Pokmon was found: escape the loop.
		if (PlayerPokemon[i].HP > 0)
		{
			CurrentBattler = PlayerPokemon[i];
			break;
		}
	}
	
	
	//=============
	//	THE TURN-BASED SYSTEM
	//=========
	
	//Infinite loop that would have to be escaped from inside there somewhere.
	while(true)
	{
	
	
	//Fainted check FOR ENEMY to determine which Pokmon will fight first.
	//Must be in the loop, because the enemy just picks the next Pokball while the player should have the choice!
	if (enemy.type == "trainer")
	{
		for (var i = 0; i < enemy.pokemon.length; i++)
		{
			//Healthy Pokmon was found: escape the loop.
			if (enemy.pokemon[i].HP > 0)
			{
				CurrentFoe = enemy.pokemon[i];
				break;
			}
		}
	}
	
	//Quick test
	CurrentFoe = enemy.pokemon[0];
	
		
		//Determine who goes first.
		//PLAYER
		if (CurrentBattler.speed >= CurrentFoe.speed)
		{
		
			//PLAYER BATTLE MENU
			
			var FightMenu = new Array("FIGHT", "BAG", "SWITCH PKMN", "FLEE");
			Menu(200, 140, 100, FightMenu);
			
			if (FightMenu[Menu.result] == "FIGHT")
			{
				
				//WHEN FIGHT WAS CHOSEN
				//Endless loop until a valid (non-"") move was chosen.
				while(true)
				{
					Menu(10, 140, 200, CurrentBattler.moves);
					
					if (CurrentBattler.moves[Menu.result] != "")
					{
						//Do the given move. Who does the move? CurrentBattler. Who takes damage? CurrentFoe.
						//Whose turn is it to attack (crucial for animation)? The player's.
						DoMove(CurrentBattler.moves[Menu.result], CurrentBattler, CurrentFoe, "player");
						break;
					}
				}
				
			}
			
		}
		
		
		else if (CurrentFoe.speed > CurrentBattler.speed)
		{
			//ENEMY AI HERE
			
		}
	
	
	
	
	}

}
*/











//Stupid battle for release 1.
function StupidBattle(enemy, special)
{
	TextBox.mapEngine = false;
	
	var EnemyPokemon;
	var EnemyPokemonAmount = 1;
	var CurrentEnemy = 0;
	
	var CurrentPlayerPokemon = 0;
	
	var TypeString = enemy.type.substr(0, 1).toUpperCase() + enemy.type.substr(1, enemy.type.length-1);
	
	
	Game.music.stop();
	var OldMusic = Game.music;
	Game.music = LoadSound("Music/GSCTrainerBattle.it");
	Game.music.play(true);
	
	
	//Wild or trainer?
	if (enemy.type == "wild")
		EnemyPokemon = enemy.pokemon,
		TextBox(TypeString + " " + enemy.pokemon.name + " appeared!");
	
	else
		TypeString = enemy.trainertype + " " + enemy.trainername,
		EnemyPokemon = enemy.pokemon[0],
		EnemyPokemonAmount = enemy.pokemon.length,
		TextBox(TypeString + " wants to battle!"),
		TextBox(TypeString + " sent out " + enemy.pokemon[CurrentEnemy].name + "!"),
		TextBox("Enemy " + (CurrentEnemy+1) + " of " + enemy.pokemon.length);
	
	
	//Keep battling until all enemy's HPs are 0 or all player's HPs are 0.
	while (true)
	{
		//PLAYER'S TURN
		if (PlayerPokemon[CurrentPlayerPokemon].HP > 0)
		{
			TextBox("Foe " + EnemyPokemon.name + "'s HP is " + EnemyPokemon.HP + ". What do you do?");
			Menu(10, 10, 150, PlayerPokemon[CurrentPlayerPokemon].moves);
			Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), black);
			DoMove(PlayerPokemon[CurrentPlayerPokemon].moves[Menu.result], PlayerPokemon[CurrentPlayerPokemon], EnemyPokemon, "player");
		}
		
		
		//ENEMY'S TURN
		//Not in demo! Battlesystem is broken anyway!
		
		
		//Trainer
		if (enemy.type == "trainer" && enemy.pokemon[CurrentEnemy].HP <= 0)
		{
			TextBox("Foe " + enemy.pokemon[CurrentEnemy].name + " fainted!");
			CurrentEnemy++;
			
			//If enemy is out of Pokmon, then stop.
			if (CurrentEnemy >= EnemyPokemonAmount)
			{
				break;
			}
			
			EnemyPokemon = enemy.pokemon[CurrentEnemy];
			enemy.pokemon[CurrentEnemy].HP = enemy.pokemon[CurrentEnemy].maxHP;
			
			TextBox(TypeString + " sent out " + enemy.pokemon[CurrentEnemy].name + "!");
			TextBox("Foe " + (CurrentEnemy+1) + " of " + enemy.pokemon.length + ".");
			
			PlayerPokemon[CurrentPlayerPokemon].HP = PlayerPokemon[CurrentPlayerPokemon].maxHP;
		}
		
		
		//Wild
		else if (enemy.type == "wild" && enemy.pokemon.HP <= 0)
		{
			TextBox("Wild " + enemy.pokemon[CurrentEnemy].name + " fainted!");
			break;
		}
		
	}
	
	
	//DUN DUN DUNNN! WON!
	Game.music.stop();
	Game.music = LoadSound("Music/WonTrainer.it");
	Game.music.play(true);
	
	
	//Trainer
	if (enemy.type == "trainer")
	{
		TextBox(TypeString + " was defeated!");
		
		for (var i = 0; i < enemy.beatenText.length; i++)
			TextBox(enemy.trainername + ": " + enemy.beatenText[i]);
		
		TextBox("Received " + enemy.money + "!");
		Player.money += enemy.money;
		enemy.beaten = true;
	}
	
	
	EnemyPokemon.HP = EnemyPokemon.maxHP;
	
	Game.music.stop();
	Game.music = OldMusic;
	Game.music.play(true);
	
	TextBox.mapEngine = true;
	
}









